DL_PublicKey_EC< EC > Class Template Reference

Elliptic Curve Discrete Log (DL) public key. More...

`#include <eccrypto.h>`

Inheritance diagram for DL_PublicKey_EC< EC >:

## Public Types

typedef EC::Point | Element
Public Types inherited from DL_PublicKeyImpl< DL_GroupParameters_EC< EC > >
typedef DL_GroupParameters_EC< EC >::Element | Element
Public Types inherited from DL_PublicKey< DL_GroupParameters_EC< EC >::Element >
typedef DL_GroupParameters_EC< EC >::Element | Element
Public Types inherited from DL_KeyImpl< X509PublicKey, DL_GroupParameters_EC< EC > >
typedef DL_GroupParameters_EC< EC > | GroupParameters

## Public Member Functions

void | Initialize (const DL_GroupParameters_EC< EC > &params, const Element &Q)
| Initialize an EC Public Key using {GP,Q}.
void | Initialize (const EC &ec, const Element &G, const Integer &n, const Element &Q)
| Initialize an EC Public Key using {EC,G,n,Q}.
void | BERDecodePublicKey (BufferedTransformation &bt, bool parametersPresent, size_t size)
| Decode subjectPublicKey part of subjectPublicKeyInfo.
void | DEREncodePublicKey (BufferedTransformation &bt) const
| Encode subjectPublicKey part of subjectPublicKeyInfo.
Public Member Functions inherited from DL_PublicKeyImpl< DL_GroupParameters_EC< EC > >
bool | Validate (RandomNumberGenerator &rng, unsigned int level) const
| Check this object for errors.
bool | GetVoidValue (const char *name, const std::type_info &valueType, void *pValue) const
| Get a named value.
void | AssignFrom (const NameValuePairs &source)
| Assign values to this object.
bool | SupportsPrecomputation () const
| Determines whether the object supports precomputation.
void | Precompute (unsigned int precomputationStorage=16)
| Perform precomputation.
void | LoadPrecomputation (BufferedTransformation &storedPrecomputation)
| Retrieve previously saved precomputation.
void | SavePrecomputation (BufferedTransformation &storedPrecomputation) const
| Save precomputation for later use.
const DL_GroupParameters< Element > & | GetAbstractGroupParameters () const
| Retrieves abstract group parameters.
DL_GroupParameters< Element > & | AccessAbstractGroupParameters ()
| Retrieves abstract group parameters.
const DL_FixedBasePrecomputation< Element > & | GetPublicPrecomputation () const
| Accesses the public precomputation.
DL_FixedBasePrecomputation< Element > & | AccessPublicPrecomputation ()
| Accesses the public precomputation.
bool | operator== (const DL_PublicKeyImpl< DL_GroupParameters_EC< EC > > &rhs) const
Public Member Functions inherited from DL_PublicKey< DL_GroupParameters_EC< EC >::Element >
bool | GetVoidValue (const char *name, const std::type_info &valueType, void *pValue) const
| Get a named value.
void | AssignFrom (const NameValuePairs &source)
| Initialize or reinitialize this key.
virtual const Element & | GetPublicElement () const
| Retrieves the public element.
virtual void | SetPublicElement (const Element &y)
| Sets the public element.
virtual Element | ExponentiatePublicElement (const Integer &exponent) const
| Exponentiates this element.
virtual Element | CascadeExponentiateBaseAndPublicElement (const Integer &baseExp, const Integer &publicExp) const
| Exponentiates an element.
Public Member Functions inherited from DL_KeyImpl< X509PublicKey, DL_GroupParameters_EC< EC > >
OID | GetAlgorithmID () const
bool | BERDecodeAlgorithmParameters (BufferedTransformation &bt)
bool | DEREncodeAlgorithmParameters (BufferedTransformation &bt) const
const DL_GroupParameters_EC< EC > & | GetGroupParameters () const
DL_GroupParameters_EC< EC > & | AccessGroupParameters ()
Public Member Functions inherited from X509PublicKey
void | BERDecode (BufferedTransformation &bt)
| Decode this object from a BufferedTransformation.
void | DEREncode (BufferedTransformation &bt) const
| Encode this object into a BufferedTransformation.
Public Member Functions inherited from ASN1CryptoMaterial< PublicKey >
void | Save (BufferedTransformation &bt) const
| DER encode ASN.1 object.
void | Load (BufferedTransformation &bt)
| BER decode ASN.1 object.
Public Member Functions inherited from ASN1Object
virtual void | BEREncode (BufferedTransformation &bt) const
| Encode this object into a BufferedTransformation.
Public Member Functions inherited from CryptoMaterial
virtual void | ThrowIfInvalid (RandomNumberGenerator &rng, unsigned int level) const
| Check this object for errors.
void | DoQuickSanityCheck () const
| Perform a quick sanity check.
Public Member Functions inherited from NameValuePairs
template<class T>
bool | GetThisObject (T &object) const
| Get a copy of this object or subobject.
template<class T>
bool | GetThisPointer (T *&ptr) const
| Get a pointer to this object.
template<class T>
bool | GetValue (const char *name, T &value) const
| Get a named value.
template<class T>
T | GetValueWithDefault (const char *name, T defaultValue) const
| Get a named value.
CRYPTOPP_DLL std::string | GetValueNames () const
| Get a list of value names that can be retrieved.
CRYPTOPP_DLL bool | GetIntValue (const char *name, int &value) const
| Get a named value with type int.
CRYPTOPP_DLL int | GetIntValueWithDefault (const char *name, int defaultValue) const
| Get a named value with type int, with default.
CRYPTOPP_DLL bool | GetWord64Value (const char *name, word64 &value) const
| Get a named value with type word64.
CRYPTOPP_DLL word64 | GetWord64ValueWithDefault (const char *name, word64 defaultValue) const
| Get a named value with type word64, with default.
template<class T>
void | GetRequiredParameter (const char *className, const char *name, T &value) const
| Retrieves a required name/value pair.
CRYPTOPP_DLL void | GetRequiredIntParameter (const char *className, const char *name, int &value) const
| Retrieves a required name/value pair.

## Additional Inherited Members

Static Public Member Functions inherited from NameValuePairs
static CRYPTOPP_DLL void | ThrowIfTypeMismatch (const char *name, const std::type_info &stored, const std::type_info &retrieving)
| Ensures an expected name and type is present.

## Detailed Description

template<class EC>
class DL_PublicKey_EC< EC >

Elliptic Curve Discrete Log (DL) public key.

Template Parameters

  EC | elliptic curve field

Definition at line 178 of file eccrypto.h.

## Member Typedef Documentation

## Element

template<class EC>

typedef EC::Point DL_PublicKey_EC< EC >::Element

Definition at line 181 of file eccrypto.h.

## Constructor & Destructor Documentation

## ~DL_PublicKey_EC()

template<class EC>

virtual DL_PublicKey_EC< EC >::~DL_PublicKey_EC | ( |  | ) |

inline virtual

Definition at line 183 of file eccrypto.h.

## Member Function Documentation

## Initialize() [1/2]

template<class EC>

void DL_PublicKey_EC< EC >::Initialize | ( | const DL_GroupParameters_EC< EC > & | params,
|  | const Element & | Q )

inline

Initialize an EC Public Key using {GP,Q}.

Parameters

  params | group parameters
  Q | the public point

This Initialize() function overload initializes a public key from existing parameters.

Definition at line 189 of file eccrypto.h.

## Initialize() [2/2]

template<class EC>

void DL_PublicKey_EC< EC >::Initialize | ( | const EC & | ec,
|  | const Element & | G,
|  | const Integer & | n,
|  | const Element & | Q )

inline

Initialize an EC Public Key using {EC,G,n,Q}.

Parameters

  ec | the elliptic curve
  G | the base point
  n | the order of the base point
  Q | the public point

This Initialize() function overload initializes a public key from existing parameters.

Definition at line 198 of file eccrypto.h.

## BERDecodePublicKey()

template<class EC>

void DL_PublicKey_EC< EC >::BERDecodePublicKey | ( | BufferedTransformation & | bt,
|  | bool | parametersPresent,
|  | size_t | size )

virtual

Decode subjectPublicKey part of subjectPublicKeyInfo.

Parameters

  bt | BufferedTransformation object
  parametersPresent | flag indicating if algorithm parameters are present
  size | number of octets to read for the parameters, in bytes

BERDecodePublicKey() the decodes subjectPublicKey part of subjectPublicKeyInfo, without the BIT STRING header.

When parametersPresent = true then BERDecodePublicKey() calls BERDecodeAlgorithmParameters() to parse algorithm parameters.

See also
  BERDecodeAlgorithmParameters

Implements X509PublicKey.

## DEREncodePublicKey()

template<class EC>

void DL_PublicKey_EC< EC >::DEREncodePublicKey | ( | BufferedTransformation & | bt | ) | const

virtual

Encode subjectPublicKey part of subjectPublicKeyInfo.

Parameters

  bt | BufferedTransformation object

DEREncodePublicKey() encodes the subjectPublicKey part of subjectPublicKeyInfo, without the BIT STRING header.

See also
  DEREncodeAlgorithmParameters

Implements X509PublicKey.

The documentation for this class was generated from the following file:

- eccrypto.h